#include <string.h>
#include <unistd.h>

#include <systypes/fcntl.h>

#include "debug.h"

/* Messages. */

char message[] = "Hello file!\n";



/* Main program. */

int main(int argc, char *argv[], char *envp[])
{
  int fd;
  char buffer[100];
  int available;

  fd = open(argv[1], O_CREAT | O_RDWR);

  if (fd == -1)
  {
    debug("Failed to open file!\n");
    return 1;
  }

  /* Write a message for reading back. */

  if (write(fd, message, strlen(message)) == -1)
  {
    debug("Failed to write to file!\n");
    return 1;
  }

  if (close(fd) == -1)
  {
    debug("Failed to close file!\n");
    return 1;
  }

  fd = open(argv[1], O_RDWR);

  if (fd == -1)
  {
    debug("Failed to open file!\n");
    return 1;
  }

  available = read(fd, buffer, 100);

  if (available == -1)
    debug("Failed to read file!\n");
  else if (!available)
    debug("Nothing read.\n");
  else
    debug_len(buffer, available);

  /* Finish off. */

  debug("At end of program!\n");

  return 0;
}
