#include <stdio.h>
#include <string.h>
#include <sys/stat.h>
#include <unistd.h>

#include <systypes/fcntl.h>

#include "debug.h"

#define logprintf(fmt, ...) sprintf(buffer, fmt, __VA_ARGS__); debug(buffer);



/* Messages. */

const char message[] = "The quick brown fox jumped over the lazy dog.\n";

/* Main program. */

int main(int argc, char *argv[], char *envp[])
{
  char buffer[32];
  struct stat st;
  int fd;

  if (argc < 2)
  {
    debug("No filename given.\n");
    return 1;
  }

  fd = open(argv[1], O_CREAT, O_RDWR);

  if (fd == -1)
  {
    debug("Failed to open file!\n");
    return 1;
  }

  if (write(fd, message, strlen(message)) == -1)
  {
    debug("Failed to write to file!\n");
    return 1;
  }

  if (fstat(fd, &st))
  {
    debug("Failed to get metadata.\n");
    return 1;
  }

  logprintf("mode: %o\n", st.st_mode);
  logprintf("uid: %d\n", st.st_uid);
  logprintf("gid: %d\n", st.st_gid);
  logprintf("size: %ld\n", st.st_size);

  if (close(fd) == -1)
  {
    debug("Failed to close file!\n");
    return 1;
  }

  /* Finish off. */

  debug("At end of program!\n");

  return 0;
}
